from pandac.PandaModules import *
from direct.task import Task
from simulation.weapon import Projectile


class Spectator:
    
    def __init__(self,game):
        self.game = game
        game.accept( "v" , self.tuggleView )
        self.view = "3rdperson"
        self.deltax = 0
        self.deltay = 0
         
         
    def tuggleView(self):
        if self.view == "3rdperson":
            self.view = "1stperson"
            self.ship.node.hide()
        else:
            self.view = "3rdperson"
            self.ship.node.show()
            
    def takeShip(self,ship):
        self.ship = ship
        self.callthink = self.ship.pilot.think 
        ship.pilot = self    
        ship.structure = 1000000
                
    def think(self,dt):
        self.callthink(dt)
        md = base.win.getPointer(0)
        x,y = md.getX(),md.getY()
        dx = (x - base.win.getXSize()/2)*.01
        dy = (y - base.win.getYSize()/2)*.01
        self.deltax = self.deltax*.9 + dx*.1
        self.deltay = self.deltay*.9 + dy*.1
        base.camera.setR(base.camera, self.deltax)
        base.camera.setH(base.camera, -self.deltax)
        base.camera.setP(base.camera, -self.deltay)
               
        base.camera.setPos(self.ship.node.getPos())
        if self.view == "3rdperson":
            base.camera.setPos(base.camera,Vec3(0,-200,10))     
    

class Navigation:
    
    def __init__(self,game):
        self.game = game
        
        game.accept( "w" , self.setAcceleration, [1] )
        game.accept( "s" , self.setAcceleration, [-1] )
        game.accept( "w-up" , self.setAcceleration, [0] )
        game.accept( "s-up" , self.setAcceleration, [0] )
        self.acceleration = 0
        
        game.accept( "v" , self.tuggleView )
        self.view = "3rdperson"
        game.accept( "mouse1" , self.fire )
        self.deltax = 0
        self.deltay = 0
         
    def reset(self):
        pass
         
    def tuggleView(self):
        if self.view == "3rdperson":
            self.view = "1stperson"
            self.ship.node.hide()
        else:
            self.view = "3rdperson"
            self.ship.node.show()
            
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
        
        
    def fire(self):
        p = Projectile()        
        self.game.world.fire(self.ship,p)
    
    
    def setAcceleration(self,a):
        self.acceleration = a
         
        
    def think(self,dt):
        md = base.win.getPointer(0)
        x,y = md.getX(),md.getY()
        
        #base.win.movePointer(0, base.win.getXSize()/2, base.win.getYSize()/2)
        
        dx = (x - base.win.getXSize()/2)*.01
        dy = (y - base.win.getYSize()/2)*.01
        self.deltax = self.deltax*.9 + dx*.1
        self.deltay = self.deltay*.9 + dy*.1
        base.camera.setR(base.camera, self.deltax)
        base.camera.setH(base.camera, -self.deltax)
        base.camera.setP(base.camera, -self.deltay)
        
        self.ship.node.setHpr(base.camera.getHpr())
        
        
        base.camera.setPos(self.ship.node.getPos())
        if self.view == "3rdperson":
            base.camera.setPos(base.camera,Vec3(0,-40,20))        
        
        if self.acceleration > 0:  
            self.ship.speed += 10
            self.ship.speed *= 1.1

            
        elif self.acceleration < 0:
            self.ship.speed -= 10
            self.ship.speed *= 0.9
            
                    
        if self.ship.speed > self.ship.maxSpeed:
             self.ship.speed = self.ship.maxSpeed
             
        if self.ship.speed < -self.ship.maxBackSpeed:
             self.ship.speed = -self.ship.maxBackSpeed
