from pandac.PandaModules import *
from direct.task import Task
import time
bufferX = 256
bufferY = 128

#class DesturbaceCamera:
    
    


class GlowCamera:
    
    def __init__(self,game):
        
        self.screenBuffer=base.win.makeTextureBuffer("Glow scene", bufferX, bufferY)
        self.screenBuffer.setSort(-3)
        self.screenBuffer.setClearColor(Vec4(0,0,0,1))
        
        self.glowCamera=base.makeCamera(self.screenBuffer, aspectRatio=base.getAspectRatio())
        self.glowCamera.node().setCameraMask(BitMask32.bit(1))
        
        tempnode = NodePath(PandaNode("temp node"))
        tempnode.setShaderInput("glow", Vec4(0.0,0.0,0.0,1.0) , 1)
        self.glowCamera.node().setInitialState(tempnode.getState())
        pl =  base.cam.node().getLens()
        self.glowCamera.node().setLens(pl)
        
        blurXBuffer = self.makeFilterBuffer(self.screenBuffer,  "Blur X", -2, "data/shaders/blurx.sha")
        blurYBuffer = self.makeFilterBuffer(blurXBuffer, "Blur Y", -1, "data/shaders/blury.sha")
        self.finalcard = blurYBuffer.getTextureCard()
        self.finalcard.reparentTo(render2d)
        self.finalcard.setAttrib(ColorBlendAttrib.make(ColorBlendAttrib.MAdd))
        game.accept("p", base.bufferViewer.toggleEnable)
        game.accept("o",       self.toggleGlow )
        
        base.bufferViewer.setPosition("llcorner")
        base.bufferViewer.setLayout("hline")
        base.bufferViewer.setCardSize(0.252,0)
        self.glowOn = True
        
        
        self.disturbanceBuffer=base.win.makeTextureBuffer("disturbance scene", bufferX, bufferY)
        self.disturbanceBuffer.setSort(-4)
        self.disturbanceBuffer.setClearColor(Vec4(1,0,0,0))
        self.disturbanceCamera=base.makeCamera(self.disturbanceBuffer, aspectRatio=base.getAspectRatio())
        self.disturbanceCamera.node().setCameraMask(BitMask32.bit(2))
        pl =  base.cam.node().getLens()
        self.disturbanceCamera.node().setLens(pl)
        tempnode = NodePath(PandaNode("temp node"))
        self.disturbanceCamera.node().setInitialState(tempnode.getState())
        self.screenTexture = self.disturbanceBuffer.getTexture( )
        
        

    def toggleGlow(self):
        pass

    def makeFilterBuffer(self,srcbuffer, name, sort, prog):
        blurBuffer=base.win.makeTextureBuffer(name, bufferX, bufferY)
        blurBuffer.setSort(sort)
        blurBuffer.setClearColor(Vec4(1,0,0,1))
        blurCamera=base.makeCamera2d(blurBuffer)
        blurScene=NodePath("new Scene")
        blurCamera.node().setScene(blurScene)
        shader = Shader.load(prog)
        card = srcbuffer.getTextureCard()
        card.reparentTo(blurScene)
        card.setShader(shader)
        return blurBuffer
    
    
    def task(self,task):        
        render.setShaderInput("time", time.time() , 1)
        return Task.cont